//
//  ConversationsProtocols.swift
//  VKExt
//
//  Created programmist_NA on 20.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import Foundation
import UIKit
import SwiftyVK
import RealmSwift

//MARK: Wireframe -
protocol ConversationsWireframeProtocol: class {
    func openConversation(from conversation: Conversation)
    func openProfile(userId: Int)
}
//MARK: Presenter -
protocol ConversationsPresenterProtocol: class {
    var messagesCount: Int? { get }
    var unreadMessagesCount: Int? { get }
    var unread: Int? { get }
    var isReachable: Bool { get }
    var searchConversations: [Conversation] { get }
    func start()
    func onEvent(message: String, _ style: MessageViewState)
    func onError(message: String, _ style: MessageViewState)
    func onLoaded()
    func onSearched()
    func onTapConversation(at indexPath: IndexPath)
    func onTapPerformProfile(userId: Int)
    func onTapReadConversation(at indexPath: IndexPath)
    func onTapUnreadConversation(at indexPath: IndexPath)
    func getConversation(at indexPath: IndexPath) -> Conversation?
    func onHandleError(error: VKError)
    func onChangeSilenceMode(peerId: Int, sound: Int)
    func onDeleteConversation(peerId: Int)
    func onSearch(q: String?)
}

//MARK: Interactor -
protocol ConversationsInteractorProtocol: class {
    var presenter: ConversationsPresenterProtocol?  { get set }
    var unread: Int { get }
    var searchConversations: [Conversation] { get }
    func start()
    func readMessage(peerId: Int)
    func markAsUnreadConversation(peerId: Int)
    func setSilenceMode(peerId: Int, sound: Int)
    func deleteConversation(peerId: Int)
    func searchConversation(q: String?, count: Int)
}

//MARK: View -
protocol ConversationsViewProtocol: class {
    var presenter: ConversationsPresenterProtocol?  { get set }
    func showStatusError(message: String, error: ErrorLocalize?, _ style: MessageViewState, with isLoading: Bool)
    func finishLoading()
    func finishSearch()
    func availabilityLoader(hasNeed: Bool)
}
